<?php

namespace FiloBlu\Flow\Console\Command;

use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;

/**
 * Class ProcessCommand
 * @package FiloBlu\Flow\Console\Command
 */
class ProcessCommand extends Command
{
    protected $state;

    public function __construct(\Magento\Framework\App\State $state) {
        $this->state = $state;
        parent::__construct();
    }

    protected function configure()
    {
        $this->setName('flow:process')->setDescription('Process data channels');
    }

    protected function execute(InputInterface $input, OutputInterface $output)
    {
        try {
            $this->state->setAreaCode(\Magento\Framework\App\Area::AREA_ADMINHTML);
        } catch (\Exception $ex) {

            $currentAreaCode = $this->state->getAreaCode();
            $output->writeln("Areacode was already set to {$currentAreaCode}");
        }
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        /** @var \FiloBlu\Flow\Cron\Fetch $cronModel */
        $cronModel = $objectManager->create('\FiloBlu\Flow\Cron\Fetch');
        $cronModel->process();
        $output->writeln('<info>Process executed !</info>');
    }

}